/*
    Project: TCTEMP
    Version: V1.14
    File   : na_filename.c

    Copyright (c) 2006-2008 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#include "na_priv.h"

BOOL NAAPI NaGetNtFileName(PWSTR pwszDest, SIZE_T cchDest,
  PCWSTR pcwszSrc)
{
    SIZE_T cchSrc;
    BOOL   fDosName;

    NaAssert(pwszDest);
    NaAssert(pcwszSrc);

    if (pwszDest == NULL || cchDest == 0 || pcwszSrc == NULL) {
        NaDbgPrintf(L"GetNtFileName: Invalid parameter!");
        return FALSE;
    }

    fDosName = pcwszSrc[0] && pcwszSrc[1] == L':';

    cchSrc = wcslen(pcwszSrc);
    if (fDosName) cchSrc += 4;

    if (cchSrc >= cchDest) {
        NaDbgPrintf(L"GetNtFileName: Buffer too small!");
        return FALSE;
    }

    if (fDosName) {
        wcscpy(pwszDest, L"\\??\\");
        wcscpy(pwszDest+4, pcwszSrc);
    } else {
        wcscpy(pwszDest, pcwszSrc);
    }

    return TRUE;
}
